"""
 Sorry, I'll do some cleanup later
"""

try:
    import psyco
    psyco.profile()
except:
    print 'Psyco not found, ignoring it'


print "\n" * 25
print "Google Summer Of Code 2005"
print "WinLibre Project"
print "\nThe Sneaky Snakes 1.0"
print "by Michael Rybak (accepted@ukr.net) and Cate Zagorska (11am@ukr.net)"
print "\nhome: http://www.winlibre.com/wiki/doku.php?id=game:snake"
print "\n\n\nAny comments/suggestions are welcomed"
print "\nPlease see notes.txt for some hints on gameplay."
print "Also see HOWTO in game itself"
raw_input("\n\nPress Enter to start.")




##import sys
##myout = file('d:\\snake.log', 'w')
##sys.stderr = myout
##sys.stdout = myout


#cleanup for compiling all
import sys, os, glob
def kill_pyc(dir):
    "delete all *.pyc files to recompile"
    for file in glob.glob(os.path.join(dir, "*.pyc")):
        os.remove(file)
    for sub in [os.path.join(dir, sub) for sub in os.listdir(dir) if os.path.isdir(os.path.join(dir, sub))]:
        kill_pyc(sub)
kill_pyc(os.getcwd())
    


#adding all subfolders for importing
sys.path.append(os.path.join(os.getcwd(), "include", "common"))
import common_
common_.prepare_for_importing()



import pygame
from pygame.locals import *

from game_mode_manager import game_mode_manager
from constants import _GM
from gm_main_menu_ import gm_main_menu
from gm_about import gm_about
from gm_howto import gm_howto
from gm_1_player_unavailable import gm_1_player_unavailable
from gm_ai import gm_ai
from gm_1_player import gm_1_player
from gm_2_players import gm_2_players
##from gm_practice import gm_practice
from gm_hotseat import gm_hotseat
##from gm_network_unavailable import gm_network_unavailable
from gm_network_choice import gm_network_choice
from gm_start_server import gm_start_server
from gm_server_waiting_for_p2 import gm_server_waiting_for_p2
from gm_server import gm_server
from gm_join_server import gm_join_server
from gm_client import gm_client
from gm_game_over import gm_game_over
from gm_settings import gm_settings
from storage import storage
import constants as c_
import random

class game:
    def __init__(self):
        pygame.init()
        random.seed()

        ds = c_._CUR_DS
        disp = pygame.display
        disp.set_caption("Please wait...")
        sz = disp.list_modes()[0]
        if ((sz[0] > ds[0]) or (sz[1] > ds[1])): sz = ds
        self.stor = storage(pygame.display.set_mode(sz, FULLSCREEN * 0))
        common_.set_my_icon(disp)

        #global settings
        self.stor.settings.set_timescale(0.25)

        disp.set_caption("WinLibre::The Sneaky Snakes")
        self.mngr_mode = game_mode_manager()
        self.create_modes()


    def create_modes(self):
        add = self.mngr_mode.add_mode
        add(_GM["MAIN_MENU"],               gm_main_menu(self.stor))
        add(_GM["ABOUT"],                   gm_about(self.stor))
        add(_GM["HOWTO"],                   gm_howto(self.stor))
        add(_GM["1_PLAYER"],                gm_1_player(self.stor))
        add(_GM["2_PLAYERS"],               gm_2_players(self.stor))
        add(_GM["AI"],                      gm_ai(self.stor))
##        add(_GM["PRACTICE"],                gm_1_player_unavailable(self.stor))
####        add(_GM["PRACTICE"],                gm_practice(self.stor))
##        adde(_GM["NETWORK_CHOICE"],          gm_network_unavailable(self.stor))
        add(_GM["NETWORK_CHOICE"],          gm_network_choice(self.stor))
        add(_GM["START_SERVER"],            gm_start_server(self.stor))
        add(_GM["SERVER_WAITING_FOR_P2"],   gm_server_waiting_for_p2(self.stor))
        add(_GM["SERVER"],                  gm_server(self.stor))
        add(_GM["JOIN_SERVER"],             gm_join_server(self.stor))
        add(_GM["CLIENT"],                  gm_client(self.stor))
        add(_GM["HOTSEAT"],                 gm_hotseat(self.stor))
        add(_GM["GAME_OVER"],               gm_game_over(self.stor))
        add(_GM["SETTINGS"],                gm_settings(self.stor))

    def start(self):
        self.mngr_mode.global_session()

def run():
    print "Initializing..."
    g = game()
    print "Starting game"
    g.start()
    print "\n\nThanks for playing!"

       
need_profile = "-pro" in sys.argv

if __name__ ==  "__main__":
    if need_profile:
        import profile
        profile.run('run()', 'gamepro')
        import pstats
        p = pstats.Stats('gamepro')
        p.sort_stats('time').print_stats(30)
        raw_input('Press any key...')

    else:
        run()
