import pygame
from pygame.constants import *
from comm_interface import comm_interface
from ci_mouse import ci_mouse
from ci_keyboard import ci_keyboard

MOUSE_EVENTS = [MOUSEMOTION, MOUSEBUTTONUP, MOUSEBUTTONDOWN]
KBD_EVENTS = [KEYDOWN, KEYUP]

class ci_both(comm_interface):
    def __init__(self, daddy, opponent):
        comm_interface.__init__(self, daddy, opponent)
        self.my_ci_mouse = ci_mouse(daddy, opponent)
        self.my_ci_kbd = ci_keyboard(daddy, opponent)

        self.my_ci = self.my_ci_mouse
    
    def get_events_(self, stor, o_data):
        if self.my_ci is self.my_ci_mouse:
            if pygame.event.peek(KBD_EVENTS):
                self.my_ci_mouse.nill_mouse_pos(stor)
                print "switching to kbd"
                pygame.event.clear(MOUSE_EVENTS)
                self.my_ci = self.my_ci_kbd
        else:
            if pygame.event.peek(MOUSE_EVENTS):
                self.my_ci = self.my_ci_mouse
                print "switching to mouse"

        return self.my_ci.get_events_(stor, o_data)
