from comm_interface import comm_interface
from server_sock import server_sock
import constants as c_
import random

class ci_server_waiting(comm_interface):
    
    def __init__(self, daddy = None, opponent = None):
        comm_interface.__init__(self, daddy, opponent)
        self.sock = server_sock()
        self.daddy.stor.sock = self.sock

    def get_events_(self, stor, o_data):
        o_data.extend([[0, 0], 0, 0])
        
        req = 0
        if not self.sock.connected:
            self.sock.try_accept_connection()
        if self.sock.connected:
            print "connected!"
            cmd, t = self.sock.read_command()
            assert(cmd == c_._CMD_CLIENT_CONNECTED)
            print "read command from client:"
            print "cmd = %d, txt = %s" % (cmd, t)
            req |= c_._REQ_CLIENT_CONNECTED
            random.seed(int(t))            

        o_data.append(req)


