from pygame.constants import *
from com_pygame_events import event_get_given_keys
import pygame
import constants as c_


class comm_interface:
    
    def __init__(self, daddy = None, opponent = None):
        self.daddy = daddy
        self.opponent = opponent
        self.scale = daddy.stor.imgf.scale

    def get_events_(self, stor, o_data):
        """ o_data = list(list(fx, fy), stick, release, req)

        fx, fy - force applied to head stick - 1 nail head down, 2
        releases, 0 makes no effect release - 1 releases current tail,
        0 makes no effect

        req - a dictionary with user requests"""
        o_data.extend([[0, 0], 0, 0, 0])
        
    def get_events(self, stor, o_data):
        "after getting events we need to round them to 3 digits"
        self.get_events_(stor, o_data)
        def form(a):
            toret = int(a * 1000)
            assert((-16000 < toret) and (toret < 16000))
            return int(a * 1000)
        o_data[0] = [form(o_data[0][0]), form(o_data[0][1])]
        self.add_common_requests(o_data)


    def add_common_requests(self, o_data):
        kbd = pygame.key.get_pressed()
        if kbd[K_ESCAPE]:
            o_data[-1] |= c_._REQ_EXIT

        event_get_given_keys([K_ESCAPE], True, True)
