import constants as c_

class game_mode_manager:
    
    def __init__(self):
        self.mode_cur_id = c_._GM["NOT_SET"]
        self.mode_start_id = c_._GM["START"]
        self.mode_stop_id = c_._GM["END"]

        self.modes = []
        self.stack = []

    def add_mode(self, id, obj):
        if len(self.modes) - 1 < id:
            self.modes.extend([0 for a in range(id - (len(self.modes) - 1))])
        self.modes[id] = obj

    def global_session(self):
        self.mode_cur_id = self.mode_start_id
        data = {}
        while self.mode_cur_id != self.mode_stop_id:
            self.stack.append(self.mode_cur_id)
            next_id = self.modes[self.mode_cur_id].session(data)

            if next_id == c_._GM["SET_TO_PREVIOUS"]:
                self.stack.pop()
                next_id = self.stack.pop() # will be placed back on next step

            print "next mode id: %s" % next_id
            self.mode_cur_id = next_id
        
