from gm_playing import gm_playing
from comm_interface import comm_interface as ci_ai_snake
from ci_ai_spider import ci_ai_spider
import ci_ai_spider as M_ci_ai_spider
import spidy as M_spidy

ci_ai_classes = (ci_ai_snake, ci_ai_spider)

class gm_ai(gm_playing):

    def __init__(self, i_storage):
        gm_playing.__init__(self, i_storage)

    def pre_session(self):
        diffic = self.chat["DIFFICULTY"]
        del self.chat["DIFFICULTY"]

        M_ci_ai_spider.difficulty_changed(diffic)
        M_spidy.difficulty_changed(diffic)

        
        gm_playing.pre_session(self)

    def get_ci_1(self):
        return self.stor.settings.get_main_ci()

    def get_ci_2(self):
        return ci_ai_classes[self.stor.settings.get_characters(self)[1]]
        
