from gm_dialog import gm_dialog
from vcg_btnboard import vcg_btnboard
from vcg_dialog import vcg_dialog
import constants as c_
from pygame.constants import K_1, K_2, K_3, K_ESCAPE

class vcg_network_choice(vcg_dialog):
    def __init__(self, daddy, stor, handler):
        vcg_dialog.__init__(self, daddy, stor, handler)

    def add_items(self):
        vcg_dialog.add_items(self)
        
        buttons = (("BTN_START", K_1, "1. Start game", 65),
                   ("BTN_JOIN", K_2, "2. Join game", 65),
                   ("BTN_CLOSE", (K_3, K_ESCAPE), "3. Back", 65))
        prc_area = (20, 20, 60, 60)
        self.items.append(vcg_btnboard(buttons, self, self.stor,
                                       self.handler, prc_area,
                                       scale_text_sizes = False))


class gm_network_choice(gm_dialog):
    def __init__(self, stor):
        gm_dialog.__init__(self, stor)

    def create_gui(self):
        return vcg_network_choice(self, self.stor, self)

    def handle_BTN_START_click(self):
        self.chat["NEWGAME"] = True
        self.mode_next_id = c_._GM["START_SERVER"]

    def handle_BTN_JOIN_click(self):
        self.chat["NEWGAME"] = True
        self.mode_next_id = c_._GM["JOIN_SERVER"]
##        self.mode_next_id = c_._GM["CLIENT"]
        


##import pygame
##
##from gm_dialog import gm_dialog, di_simple
##from constants import _GM
##
###local consts
##(NCI_ID_SERVER
##,NCI_ID_CLIENT
##,NCI_ID_BACK
##) = range(3)
##
##class gm_network_choice(gm_dialog):
##
##    def __init__(self, i_storage):
##        gm_dialog.__init__(self, i_storage)
##        
##        #add necessary dialog items
##        self.items.append(di_simple("1. Start game (server)", None, NCI_ID_SERVER, 49, 60))
##        self.items.append(di_simple("2. Join game (client)", None, NCI_ID_CLIENT, 50, 60))
##        self.items.append(di_simple("3. Back", None, NCI_ID_BACK, [51, 27], 60))
##
##        self.count = 0
##
##    def dlg_key_press(self, di_return_id):
##                tmp = di_return_id
##                if not (tmp is None):
##                    if tmp == NCI_ID_SERVER:
##                        self.chat["NEWGAME"] = True
##                        self.mode_next_id = _GM["SERVER_WAITING_FOR_P2"]
##                    if tmp == NCI_ID_CLIENT:
##                        self.chat["NEWGAME"] = True
##                        self.mode_next_id = _GM["CLIENT"]
##                    if tmp == NCI_ID_BACK:
##                        self.mode_next_id = _GM["2_PLAYERS"]
##        
##    
