from gm_network import gm_network
import constants as c_

class gm_server(gm_network):
    def __init__(self, i_storage):
        gm_network.__init__(self, i_storage)

    def assign_players_me_he(self):
        self.p_me = self.stor.p1
        self.p_he = self.stor.p2

    def get_ci_1(self):
        return self.stor.settings.get_main_ci()

    def send_first(self):
        return True

    def server_side(self):
        return True

    def get_cloud_dxy_from_net_stor(self):
        return self.net_stor.my_in_vals.cloud_dxy

    def get_events_from_net_stor(self):
        return self.net_stor.my_in_vals.events
    
    def new_event(self, event_name, params):
        #instead of posting to self.events, as daddy does,
        #we post this to my_out
        self.net_stor.my_out_lock.acquire()
        self.net_stor.my_out_vals.events.extend([event_name, params[0], params[1]])
        self.net_stor.my_out_lock.release()

    def handle_request_EXIT(self, player = None):
        if player is self.stor.p2:
            print "client disconnected"
            self.chat["NEWGAME"] = True
            self.mode_next_id = c_._GM["SERVER_WAITING_FOR_P2"]
        else:
            gm_network.handle_request_EXIT(self, player)
