import constants as c_
from pygame import Rect

class dirty_rects:
    def __init__(self, stor):
        self.stor = stor
        self.new_dirty_rects, self.old_dirty_rects, self.new_unerase_rects = [], [], []

        for rects in (self.new_dirty_rects,
                      self.old_dirty_rects,
                      self.new_unerase_rects):
            for i in range(c_._MAX_DIRTY_RECTS):
                rects.append(Rect(0, 0, 0, 0))

    def new_session(self):
        self.free_new = 0
        self.free_unerase = 0
        self.free_old = 0

        self.clip = self.stor.screen.get_rect()


    def post_frame(self):
        t = self.old_dirty_rects
        self.old_dirty_rects = self.new_dirty_rects
        self.new_dirty_rects = t

        self.free_old = self.free_new
        self.free_new = 0
        self.free_unerase = 0

    def new_rect(self, img_r):
        self.new_dirty_rects[self.free_new] = Rect(self.clip.clip(img_r))
        self.free_new += 1
        
    def new_unerase_rect(self, img_r):
        self.new_unerase_rects[self.free_unerase] = Rect(self.clip.clip(img_r))
        self.free_unerase += 1
        
        
        



 
