class mouse_sensitive_rect:
    def __init__(self):
        self.area = None

    def mouse_is_moving(self, pos):
        if self.simple_collidepoint(pos):
            self.on_mouse_move(pos)
            if not self.has_mouse:
                self.has_mouse = True
                self.on_got_mouse(pos)
        else:
            self.on_mouse_move_away()
            if self.has_mouse:
                self.has_mouse = False
                self.on_lost_mouse()

    def mouse_is_pressed(self, buttons, pos):
        for i in range(3):
            if buttons[i]:
                if self.has_mouse and (not self.has_mouse_down[i]):
                    self.has_mouse_down[i] = True
                    self.on_mouse_down(i, pos)
            else:
                if self.has_mouse_down[i]:
                    self.has_mouse_down[i] = False
                    self.on_mouse_up(i, pos)
            
    def simple_collidepoint(self, pos):
        try:
            return self.area.collidepoint(pos)
        except:
            print "area missing for", self

    def on_mouse_move(self, pos):
        pass

    def on_mouse_move_away(self):
        pass

    def on_got_mouse(self, pos):
        pass

    def on_lost_mouse(self):
        pass

    def on_mouse_down(self, button, pos):
        pass

    def on_mouse_up(self, button, pos):
        pass


    def on_key_down(self, key):
        pass
    
    def on_key_up(self, key):
        pass
    

    def new_session(self):
        self.has_mouse = False
        self.has_mouse_down = [False] * 3 #left, middle and right mouse buttons
        self.visible = True

    def get_visible(self):
        return self.visible

