from vis_comp_group import vis_comp_group, arr_id
from vcg_empty import vcg_empty
from vc_button_text import vc_button_text
from vis_comp import vis_comp
from pygame.constants import K_UP, K_DOWN
from img_holder import img_holder
import constants as c_


class vcg_scroll(vis_comp_group):
    def __init__(self, name, vmin, vmax, daddy, stor, handler,
                 prc_area = (0, 0, 100, 100), vinit = None,
                 hotkeys_updown = (K_UP, K_DOWN),
                 arrangement = "VERTICAL"):
        self.name = name
        
        self.vmin = vmin
        self.vmax = vmax
        
        if vinit == "min": vinit = vmin
        if vinit == "max": vinit = vmax
        if vinit == None: vinit = vmin
        self.vinit = vinit
        self.val = self.vinit

        self.scroll_arng = arrangement

        if not hotkeys_updown: hotkeys_updown = (None, None)
        self.hotkeys_updown = hotkeys_updown

        vis_comp_group.__init__(self, daddy, stor, handler, prc_area,
                                arrangement = arrangement,
                                arrng_proport = [10, 80, 10])

    def add_items(self):
        def add(obj):
            self.items.append(obj)
            
        self.ar_id = arr_id(self.scroll_arng)

        letter_up = img_holder(c_._IG_SCROLL_ARROW, 0).as_str()
        self.btn_up = vc_button_text("BTN_UP", self.hotkeys_updown[0],
                                     self, letter_up, 60,
                                     RM = vis_comp._RM_ALWAYS,
                                     button_stretched = True)
        add(self.btn_up)

        letter_down = img_holder(c_._IG_SCROLL_ARROW, 1).as_str()
        add(vcg_empty(self, self.stor, self.handler, None))
        self.btn_down = vc_button_text("BTN_DOWN", self.hotkeys_updown[1],
                                       self, letter_down, 60,
                                       RM = vis_comp._RM_ALWAYS,
                                       button_stretched = True)
        add(self.btn_down)

    def get_child_handler(self):
        return self

    def handle_BTN_UP_click(self):
        if self.val > self.vmin:
            self.set_new_value(self.val - 1)

    def handle_BTN_DOWN_click(self):
        if self.val < self.vmax:
            self.set_new_value(self.val + 1)

    def set_new_value(self, val):
        self.val = val
        getattr(self.handler, "handle_%s_value_changed" % self.name)(self.val)

    def new_session(self):
        self.val = self.vinit
        vis_comp_group.new_session(self)    

