from sock import sock
import constants as c_
import random

class client_sock(sock):
    def __init__(self, server_host):
        sock.__init__(self, server_host)
        print "client trying to connect to %s..." % server_host
        self.try_establish_connection()

    def try_establish_connection(self):
        assert(not self.curcon) #we shouldn't have tried to set a connection when connected
        
        sav_timeout = self.sockobj.gettimeout()
        self.sockobj.settimeout(2) #attempt to connect for 2 seconds
        try:
            self.connected = True
            self.sockobj.connect((self.host, self.port))
            con = self.sockobj
        except:
            self.connected = False

        self.sockobj.settimeout(sav_timeout)

        if self.connected:
            self.curcon = con
            rnd = random.randint(0, 65535)            
            self.send_command(c_._CMD_CLIENT_CONNECTED, rnd)
            random.seed(rnd)
            print "connected!"

        return self.connected        

