from snake import snake
from player_info import player_info

class player:

    def __init__(self, gm, stor, player_id, name = "Anonymous"):
        self.gm = gm
        self.stor = stor
        self.player_id = player_id
        self.string = "PLAYER %d" % player_id
        self.name = name
        
        ph = self.stor.physics
        self.char = None
        self.comm = None
        self.info = player_info(self.stor, self)

    def set_comm_interface(self, i_comm):
        self.comm = i_comm
        
    def render_step0(self, stor, visible):
        self.char.render_step0(stor, visible)

    def render_step1(self, stor, visible):
        self.char.render_step1(stor, visible)

    def apply_user_action(self, data):
        move, stick, release_bullet, req = data
        b = self.char.balls[0]
        b.user_force = (move[0] / 1000.0, move[1] / 1000.0)
#        print "sticked = %s" % stick
        if stick != 0:
            b.sticked = stick == 1

        if release_bullet:
            self.char.try_release_bullet()

    def set_target(self, target):
        self.char.target_ball = target
