from my_maths import *
from img_holder import img_holder
import constants as c_
import pygame
from common_ import blit_part_
import toolbar

class arrow:
    def __init__(self, stor, snake, img_id):
        self.stor = stor
        self.snake = snake

        self.ih = img_holder(c_._IG_ARROW, img_id)
        self.cached_rect = None
        scale = self.stor.imgf.scale
        self.toolbar_y = toolbar.get_height(scale)

    def render(self, stor, visible):
        return
        
        if not visible:
            if self.cached_rect:
                blit_(stor, None, self.cached_rect, visible)
                self.cached_rect = None
            return

        ball = self.snake.last_attached
        if not ball.releasable:
            return
        a = ball.crd
        s = ball.speed

        dest = a[0] + s[0], a[1] + s[1]
        
        x, y = stor.physics.world_to_scr(dest)
        ang = angle_a_to_b(a, dest)

        img = stor.imgf.get_image(self.ih, angle = ang)
        rect = pygame.Rect(img.img[1])
        rect.center = (x, y)

        #don't spoil toolbar
        sz = rect.size
        srect = pygame.Rect(0, 0, sz[0], sz[1])
        ty = self.toolbar_y
        if rect.bottom < ty:
            return
        if rect.top < ty:
            d = ty - rect.top
            rect.top += d
            rect.height -= d
            srect.top += d
            srect.height -= d

        blit_part_(self.stor, img.img[0], rect, srect, visible)
        self.cached_rect = rect
        

 
