import constants as c_
from snake_body import snake_body
from snd_holder import snd_holder

class snake_tail(snake_body):
    _SH_HIT = snd_holder(c_._SG_HITS, 2)

    def __init__(self, snake, id,
                 prev_ball, next_ball, obj_group, stor,
                 x, y, 
                 img_gr = c_._IG_BODY, img_id = 0,
                 friction = 0.01, solidity = 1.0,
                 string = "anonymous ball",
                 detached_friction = 0.01,
                 def_size = c_._WH_TAIL):
        snake_body.__init__(self, snake, id, prev_ball, next_ball,
                            obj_group, stor, x, y, 
                            img_gr, img_id,
                            0.1, solidity,
                            string,
                            detached_friction,
                            def_size)
        self.is_tail = True
        
    def damagable(self):
        return False

    def may_glue_to_last_only(self):
        return True

    def need_sound_when_hit_b(self, b):
        return ((b.obj_gr in c_._OGs_PLAYERS) and
                (b.obj_gr != self.obj_gr))
