import pygame  
from pygame.constants import *
from com_pygame_events import event_get_given_keys
import constants as c_

from comm_interface import comm_interface

class ci_keyboard(comm_interface):
    
    def __init__(self, daddy, opponent):
        comm_interface.__init__(self, daddy, opponent)
        self.layout = daddy.get_kbd_layout()
        self.scale = (0.5, 0.5)
##        self.scale = tuple([x / 2.0 for x in self.scale])
    
    def get_events_(self, stor, o_data):
        lay = self.layout
        ee = event_get_given_keys(lay.values(), True, True)
        kbd = pygame.key.get_pressed()
        dir = self.daddy.char.get_cur_head_dir()

        dir = (dir[0] * self.scale[0], dir[1] * self.scale[1])
        #move?
        move_k = (  ##(kbd[lay['FFORWARD']] and 2.0) or
                    (kbd[lay['FORWARD']] and 1.0) or
                    (kbd[lay['BACKWARD']] and -1.0) or
                    0.0)
        move_d = [dir[0] * move_k, dir[1] * move_k]
                
        
        #turn?
        turn_k = (  (kbd[lay['TURN LEFT']] and -1.0)
                 or (kbd[lay['TURN RIGHT']] and 1.0)
                 or 0.0)
#        if move_k > 1e-5: turn_k *= 0.5
        turn_d = [-dir[1] * turn_k, dir[0] * turn_k]

        #accel turn?
        accel = 1
        if kbd[lay['INCR_K']]: accel *= 2
        if kbd[lay['DECR_K']]: accel *= 0.5
    
        
        turn_d = map(lambda x: x * 0.03 * accel, turn_d)
        move_d = map(lambda x: x * 0.05 * accel, move_d)
        
        f = [x+y for x, y in [(turn_d[i], move_d[i]) for i in range(0, 2)]]
        o_data.append(f)

        stick = 0
        for e in ee:
            if e.key == lay["NAIL"]:
                if e.type == KEYDOWN:
                    stick = 1
                else:
                    stick = 2
                
        release_bullet = 0
        for e in ee:
            if e.key == lay["FIRE"]:
                if e.type == KEYDOWN:
                    release_bullet = 1

        o_data.append(stick)
        o_data.append(release_bullet)

        req = 0
        o_data.append(req)

#	print "forward pressed: %s" % kbd[lay['FORWARD']]	
