import pygame
from pygame.constants import *
from math import *

from comm_interface import comm_interface

def time_scale_changed(new_ts):
    ci_mouse.time_k = pow(ci_mouse.def_time_k, new_ts)
    
class ci_mouse(comm_interface):
    def_time_k = 0.88
    time_k = def_time_k
    
    def __init__(self, daddy, opponent):
        comm_interface.__init__(self, daddy, opponent)
        self.scale = (1.0 / 25.0,) * 2
#        self.scale = tuple([x / 22.0 for x in self.scale])
    def nill_mouse_pos(self, stor):
        """
        needed for ci_both to disregard current mouse position
        which is set in ci_mouse.get_events_ after reading mousepos
        """
        pygame.mouse.set_pos(stor.physics.world_to_scr((0, 0))) 
    
    def get_events_(self, stor, o_data):
        pygame.event.get([MOUSEMOTION])
        f = pygame.mouse.get_pos()
        f = stor.physics.scr_to_world(f)
        f = [f[0], f[1]]
        sf = f[:]
        f[0] *= self.scale[0] 
        f[1] *= self.scale[1]
        o_data.append(f)
        k = ci_mouse.time_k
        pygame.mouse.set_pos(stor.physics.world_to_scr((sf[0] * k, sf[1] * k)))

        stick = 0
        release_bullet = 0
        req = 0
        for e in pygame.event.get([MOUSEBUTTONUP, MOUSEBUTTONDOWN]):
            if e.button == 1:
                if e.type == MOUSEBUTTONDOWN:
                    stick = 1
                else:
                    stick = 2
            elif e.button == 3:
                if e.type == MOUSEBUTTONDOWN:
                    release_bullet = 1
#        if stick == 1:
#            print "stick!"
#        if stick == 2:
#            print "stick up!"
        o_data.append(stick)
        o_data.append(release_bullet)
        o_data.append(req)
