import pygame
from pygame.constants import *

def event_get_given_keys(needed_keys, get_keydown = False, get_keyup = False):
    toretback = []
    toret = []
    needed = []
    if get_keydown: needed.append(KEYDOWN)
    if get_keyup: needed.append(KEYUP)
    assert len(needed) > 0
    
    for e in pygame.event.get(needed):
        if e.key in needed_keys:
            toret.append(e)
        else:
            toretback.append(e)

    for e in toretback: pygame.event.post(e)
    return toret

    
