"""
 Sorry, I'll do some cleanup later



 All constants

GRAPHICS

    _GM
        GameModeID's
        
    _CL
        Color

    _IG
        Image Group

    _IG_SZ_
        Image Group Size



SOUNDS

    _SG
        Sound Group
"""

import pygame, toolbar
from pygame.constants import *

#abc
_S_ABC = "".join([chr(i + ord("A")) for i in range(26)] +
                 [str(i + 1) for i in range(9)] +
                 ["0.()-,'@:;\/! "])


#game modes

_GM = {"NOT_SET"                        : 0,
       "MAIN_MENU"                      : 1,
       "ABOUT"                          : 2,
       "GAME_OVER"                      : 3,
       "PRACTICE"                       : 4,
       "HOTSEAT"                        : 5,
       "NETWORK_CHOICE"                 : 6,
       "START_SERVER"                   : 7,
       "SERVER_WAITING_FOR_P2"          : 8,
       "SERVER"                         : 9,
       "JOIN_SERVER"                    : 10,
       "CLIENT"                         : 11,
       "1_PLAYER"                       : 12,
       "2_PLAYERS"                      : 13,
       "HOWTO"                          : 14,
       "AI"                             : 15,
       "SETTINGS"                       : 16,

       "START"                          : 1,
       "END"                            : 100,

       "DO_NOT_CHANGE"                  : 10000,
       "SET_TO_PREVIOUS"                : 10001,
       }

#colors
_CL_WHITE    = (255, 255, 255)
_CL_RED      = (255,   0,   0)
_CL_PURPLE   = (255,   0, 255)


#image groups
(_IG_ABC
,_IG_BODY
,_IG_HEAD
,_IG_HEAD_FACE
,_IG_TAIL     
,_IG_WALL
,_IG_ICON_NONE
,_IG_NUMBERS_BLUE
,_IG_NUMBERS_GREEN
,_IG_NUMBERS_FPS
,_IG_STRINGS
,_IG_STRINGS_ON_THE_FLY
,_IG_BACKGROUNDS
,_IG_TOOLBARS
,_IG_MAIN_MENU
,_IG_GAME_OVER
,_IG_MSGBOXES
,_IG_CLOUD
,_IG_BOUNTY_321
,_IG_BOUNTY_BAD
,_IG_BOUNTY_HP
,_IG_BOUNTY_HP2
,_IG_HOWTO
,_IG_FLOWER_BLUE
,_IG_FLOWER_GREEN
,_IG_MEAT
,_IG_MEAT_SPDR
,_IG_MEAT_SPDR_EYE
,_IG_ARROW
,_IG_SCROLL_ARROW
,_IG_NAIL
,_IG_RELEASABLE_BODY
,_IG_SHOT
,_IG_SERVER_ICONS
,_IG_OPTIONLIST_SELECTION
,_IG_SPDR_EYE
,_IG_SPIDY
,_IG_SPDR_TONGUE
,_IG_CREDITS
,_IG_DIFFIC
,_IG_2_PLAYERS
,_IG_LOGO
) = range (42)
#subgroups data
_in_IG_BODY_SPIDER_ID0 = 2
_in_IG_HEAD_SPIDER_ID0 = 2
#sizes (for loading stuff like "head%d.bmp" % count)
_IG_SZ_HEAD_FACE = 5
_IG_SZ_WALL = 2
_IG_SZ_BACKGROUNDS = 6
_IG_SZ_TOOLBARS = 5
_IG_SZ_MAIN_MENU = 7
_IG_SZ_MSGBOXES = 4
_IG_SZ_GAME_OVER = 6
_IG_SZ_CLOUD = 3
_IG_SZ_BOUNTY_321 = 5
_IG_SZ_BOUNTY_BAD = 1
_IG_SZ_BOUNTY_HP = 1
_IG_SZ_BOUNTY_HP2 = 1
_IG_SZ_HOWTO = 5
_IG_SZ_FLOWER = 11
_IG_SZ_ABC = len(_S_ABC)
_IG_SZ_SERVER_ICONS = 9
_IG_SZ_OPTIONLIST_SELECTION = 2
_IG_SZ_SPDR_EYE = 4
_IG_SZ_SPIDY = 8
_IG_SZ_CREDITS = 2
_IG_SZ_DIFFIC = 3
_IG_SZ_2_PLAYERS = 2
_IG_SZ_LOGO = 2

#alpha blending
_IG_AL_CLOUD = 160
_IG_AL_CLOUD_CAPTURE = 200


#strings to be pre-rendered
#used to create _IG_STRINGS
# ("text", FONT_SIZE, ALPHA_VALUE)
_RENDERED_STRS = [("fps", 32, 150)
                 ,("Waiting for opponent ...", 50, 148)
                 ,("", 50, 148) # for blinking (previous)
                 ,("1 PLAYER", 65, 255)
                 ,("2 PLAYERS", 50, 255)
                 ,("SOUND", 90, 255)
                 ,("SOUND OFF", 57, 255) #not used any more
                 ,("HOWTO", 70, 255)
                 ,("PLAY", 70, 255)
                 ,("CREDITS", 70, 255)
                 ,("EXIT", 120, 255)
                 ]

#corresponding ID's
_IG_S_FPS = 0 
_IG_S_WAITING_FOR_OPPONENT = 1
(_IG_S_1_PLAYER
,_IG_S_2_PLAYERS
,_IG_S_SOUND_ON
,_IG_S_SOUND_OFF
,_IG_S_HOWTO
,_IG_S_PLAY
,_IG_S_CREDITS
,_IG_S_EXIT
) = range(3, 11)




#object groups on field
(_OG_PLAYER1
,_OG_PLAYER2
,_OG_WALLS
,_OG_CLOUDS
,_OG_BOUNTIES
 ) = range(5)

_OGs_PLAYERS = (_OG_PLAYER1, _OG_PLAYER2)



#controls
##_P1_KBD = {"TURN LEFT"  : 103,
##           "TURN RIGHT" : 106,
##           "FORWARD"    : 121,
##           "BACKWARD"   : 104,
##           "NAIL"       : 96,
##           "FIRE"       : K_LALT,
##           "INCR_K"     : 51,
##           "DECR_K"     : 101
##           }
##
##_P2_KBD = {"TURN LEFT"  : K_KP4,
##           "TURN RIGHT" : K_KP6,
##           "FORWARD"    : K_KP8,
##           "BACKWARD"   : K_KP5,
##           "NAIL"       : K_BACKSPACE,
##           "FIRE"       : K_RIGHT,
##           "INCR_K"     : K_PAGEUP,
##           "DECR_K"     : K_PAGEDOWN
##           }

####_P_KBD = {"TURN LEFT"  : K_LEFT,
####          "TURN RIGHT" : K_RIGHT,
####          "FORWARD"    : K_UP,
####          "BACKWARD"   : K_DOWN,
####          "NAIL"       : 121,
####          "FIRE"       : K_RALT,
####          "INCR_K"     : 111,
####          "DECR_K"     : 108
####          }

_P_KBD = {"TURN LEFT"  : K_LEFT,
          "TURN RIGHT" : K_RIGHT,
          "FORWARD"    : K_UP,
          "BACKWARD"   : K_DOWN,
          "NAIL"       : 96,
          "FIRE"       : 99,
          "INCR_K"     : 51,
          "DECR_K"     : 101
          }



##
_PORT = 32020

##client/server commands
(_CMD_CLIENT_CONNECTED
,_CMD_USER_INPUT
,_CMD_STATUS_UPDATE
) = range(3)

#
_MAX_FPS = 25

#screen
WH_DEF_DS = (800, 600) #size to set _WH_SC
_DEF_DS = (1024, 768) #default display size
_CUR_DS = (800, 600) #current display size
##_CUR_DS = _DEF_DS 
##_CUR_DS = _DEF_DS

#requests (from common interfaces)
#(binary, to send via network in 1 byte)
_REQ_EXIT = 1
_REQ_CLIENT_CONNECTED = 2
_NUM_REQ = 2

_S_REQ = ('EXIT', 'CLIENT_CONNECTED')

(_EVENT_NEW_BOUNTY
,_EVENT_RELEASE_BOUNTY
,_EVENT_BOUNTY_IDLE
) = range(3) #must be lower than 256 to send via net; params too!!!

_S_GM_EVENTS = ('NEW_BOUNTY', 'RELEASE_BOUNTY', 'BOUNTY_IDLE')

#sprite needed sizes
_WH_BODY = (10, 10)
_WH_HEAD = (15, 15)
_WH_SPDR_HEAD = (35, 35)
_WH_TAIL = (20, 20)
_WH_WALL = (42, 42)
_WH_HEAD_FACE = tuple([int(x / 17.0 * 31.0) for x in _WH_HEAD])
_WH_CLOUD = (80, 80)
_WH_BOUNTY = (40, 40)
_WH_BOUNTY_321 = (40, 40)
_WH_FLOWER = (toolbar.toolbar.default_height_,) * 2
_WH_MEAT_MIN = (0, int(_WH_BODY[1] * 0.7))
_WH_MEAT_MAX = (_WH_BODY[0] * 20, int(_WH_BODY[1] * 0.7))
_WH_ARROW = (25, 25)
_WH_NAIL = (18, 18)
_WH_ABC = (65, 65)
_WH_MSGBOXES = (400, 300)
_WH_VIS_ICON = (130, 130)
_WH_SPDR_LEG_0 = (10, 10)
_WH_SPDR_LEG_1 = (13, 13)
_WH_SPDR_LEG_2 = (17, 17)
_WH_SPDR_EYE = (14, 14)
_WH_SPIDY = (10, 10)
_WH_SPDR_TONGUE = (15, 15)


_WH_SC = float(_DEF_DS[0]) / WH_DEF_DS[0]
(_WH_BODY, _WH_HEAD, _WH_SPDR_HEAD, _WH_TAIL, _WH_WALL, _WH_HEAD_FACE,
 _WH_CLOUD, _WH_BOUNTY, _WH_BOUNTY_321, _WH_FLOWER, _WH_MEAT_MIN,
 _WH_MEAT_MAX, _WH_ARROW, _WH_NAIL, _WH_ABC, _WH_MSGBOXES, _WH_VIS_ICON,
 _WH_SPDR_LEG_0, _WH_SPDR_LEG_1, _WH_SPDR_LEG_2, _WH_SPDR_EYE,
 _WH_SPIDY, _WH_SPDR_TONGUE) = map(
     lambda (x, y): (int(x * _WH_SC), int(y * _WH_SC)),
(_WH_BODY, _WH_HEAD, _WH_SPDR_HEAD, _WH_TAIL, _WH_WALL, _WH_HEAD_FACE,
 _WH_CLOUD, _WH_BOUNTY, _WH_BOUNTY_321, _WH_FLOWER, _WH_MEAT_MIN,
 _WH_MEAT_MAX, _WH_ARROW, _WH_NAIL, _WH_ABC, _WH_MSGBOXES, _WH_VIS_ICON,
 _WH_SPDR_LEG_0, _WH_SPDR_LEG_1, _WH_SPDR_LEG_2, _WH_SPDR_EYE,
 _WH_SPIDY, _WH_SPDR_TONGUE))


##_WH_BODY = (15, 15)
##_WH_HEAD = (17, 17)
##_WH_TAIL = (30, 30)
##_WH_WALL = (72, 72)
##_WH_HEAD_FACE = tuple([int(x / 17.0 * 31.0) for x in _WH_HEAD])

_MAX_DIRTY_RECTS = 300

(_PRES_MODE_PREVIOUS_SCREEN
,_PRES_MODE_PREVIOUS_BACK
 ) = range(2)



#sound groups
(_SG_HITS
,_SG_BTN
,_SG_FIRE
,_SG_BODY
,_SG_BOUNTY
,_SG_TIME
,_SG_MISC
) = range(7)

#sound group sizes

_SG_SZ_HITS = 4
_SG_SZ_BTN = 3
_SG_SZ_BODY = 1
_SG_SZ_FIRE = 5
_SG_SZ_BOUNTY = 8
_SG_SZ_MISC = 1


_DEF_SFX_VOL = 6
_DEF_MUS_VOL = 10
