from gm_dialog import gm_dialog
from vcg_btnboard import vcg_btnboard
from vcg_dialog import vcg_dialog
import constants as c_
from pygame.constants import K_1, K_2, K_3, K_ESCAPE
from img_list import img_list

class vcg_2_players(vcg_dialog):
    def __init__(self, daddy, stor, handler):
        vcg_dialog.__init__(self, daddy, stor, handler)

    def add_items(self):
        vcg_dialog.add_items(self)

        btn_imgs = img_list(self.stor.imgf, (c_._IG_2_PLAYERS, 0, 2))
        text = ["\\S(5.0, 1.0)\\" + ih.as_str() for ih in btn_imgs]
        buttons = (("BTN_HOTSEAT", text[0], 130),
                   ("BTN_NETWORK", text[1], 130))
        prc_area = (20, 20, 60, 60)
        self.items.append(vcg_btnboard(buttons, self, self.stor,
                                       self.handler, prc_area,
                                       scale_text_sizes = False))


class gm_2_players(gm_dialog):
    def __init__(self, stor):
        gm_dialog.__init__(self, stor)

    def create_gui(self):
        return vcg_2_players(self, self.stor, self)

    def handle_BTN_HOTSEAT_click(self):
        self.chat["NEWGAME"] = True
        self.mode_next_id = c_._GM["HOTSEAT"]

    def handle_BTN_NETWORK_click(self):
        self.chat["NEWGAME"] = True
        self.mode_next_id = c_._GM["NETWORK_CHOICE"]
        

##
##
##import pygame
##
##from gm_dialog import gm_dialog, di_simple
##from constants import _GM
##
###local consts
##(MMI_ID_HOTSEAT
##,MMI_ID_NETWORK
##,MMI_ID_BACK
##) = range(3)
##
##class gm_2_players(gm_dialog):
##
##    def __init__(self, i_storage):
##        gm_dialog.__init__(self, i_storage)
##        
##        #add necessary dialog items
##        self.items.append(di_simple("1. Hotseat", None, MMI_ID_HOTSEAT, 49, 60))
##        self.items.append(di_simple("2. Network", None, MMI_ID_NETWORK, 50, 60))
##        self.items.append(di_simple("3. Back",    None, MMI_ID_BACK,    [51, 27], 60))
##
##    def dlg_key_press(self, di_return_id):
##                tmp = di_return_id
##                if not (tmp is None):
##                    if tmp == MMI_ID_NETWORK:
##                        self.chat["NEWGAME"] = True
##                        self.mode_next_id = _GM["NETWORK_CHOICE"]
##                    if tmp == MMI_ID_HOTSEAT:
##                        self.chat["NEWGAME"] = True
##                        self.mode_next_id = _GM["HOTSEAT"]
##                    if tmp == MMI_ID_BACK:
##                        self.mode_next_id = _GM["MAIN_MENU"]
##        
##    
