from gm_network import gm_network
import constants as c_
from client_sock import client_sock

class gm_client(gm_network):
    def __init__(self, i_storage):
        gm_network.__init__(self, i_storage)

    def assign_players_me_he(self):
        self.p_me = self.stor.p2
        self.p_he = self.stor.p1

    def get_ci_2(self):
        return self.stor.settings.get_main_ci()

    def pre_session(self):
        host = self.chat["SERVER_HOST"]
        del self.chat["SERVER_HOST"]
        
        self.stor.sock = client_sock(host)
        if not self.stor.sock.connected:
            print "connection broken or not set"
            self.mode_next_id = c_._GM["SET_TO_PREVIOUS"]
        else:
            gm_network.pre_session(self)

    def send_first(self):
        return False

    def client_side(self):
        return True

    def get_cloud_dxy_from_net_stor(self):
        return self.net_stor.his_in_vals.cloud_dxy

    def get_events_from_net_stor(self):
        return self.net_stor.his_in_vals.events

    def handle_request_EXIT(self, player = None):
        if player is self.stor.p1:
            print "server disconnected"
        gm_network.handle_request_EXIT(self, player)
