import pygame

from gm_dialog import gm_dialog, di_simple
from constants import _GM

#local consts
(MMI_ID_PRACTICE
,MMI_ID_HOTSEAT
,MMI_ID_NETWORK
,MMI_ID_ABOUT
,MMI_ID_QUIT
) = range(5)

class gm_main_menu(gm_dialog):

    def __init__(self, i_storage):
        gm_dialog.__init__(self, i_storage)
        
        #add necessary dialog items
        self.items.append(di_simple("1. Practice mode", None, MMI_ID_PRACTICE, 49, 60))
        self.items.append(di_simple("2. Hotseat", None, MMI_ID_HOTSEAT, 50, 60))
        self.items.append(di_simple("3. Network", None, MMI_ID_NETWORK, 51, 60))
        self.items.append(di_simple("4. About", None, MMI_ID_ABOUT, 52, 60))
        self.items.append(di_simple("5. Quit", None, MMI_ID_QUIT, [53, 27], 60))

    def dlg_key_press(self, di_return_id):
                tmp = di_return_id
                if not (tmp is None):
                    if tmp == MMI_ID_PRACTICE:
                        self.chat["NEWGAME"] = True
                        self.mode_next_id = _GM["PRACTICE"]
                    if tmp == MMI_ID_NETWORK:
                        self.chat["NEWGAME"] = True
                        self.mode_next_id = _GM["NETWORK_CHOICE"]
                    if tmp == MMI_ID_HOTSEAT:
                        self.chat["NEWGAME"] = True
                        self.mode_next_id = _GM["HOTSEAT"]
                    if tmp == MMI_ID_ABOUT:
                        self.mode_next_id = _GM["ABOUT"]
                    if tmp == MMI_ID_QUIT:
                        self.mode_next_id = _GM["END"]
        
    
