from vcg_btnlist import vcg_btnlist
from vcg_board import vcg_board
import constants as c_

class vcg_btnboard(vcg_board):
    
    def __init__(self, buttons, daddy, stor, handler,
                 prc_area = (0, 0, 100, 100), board_img_id = 0, scale_text_sizes = True):
        """__init__(self, buttons, daddy, stor, handler, prc_area, board_img_id = 0, scale_text_sizes = True)
        buttons = ((name1, hotkeys1, text1, size1, alpha1),..)
        hotkeys, size and alpha may be missing
        size missing means take previous'
        alpha or hotkeys missing means None
        """
        self.scale_text_sizes = scale_text_sizes
        self.buttons = buttons
        vcg_board.__init__(self, daddy, stor, handler, prc_area, board_img_id)



    def add_items(self):
        vcg_board.add_items(self)
        
        self.btnlist = vcg_btnlist(self.buttons, self, self.stor, self.handler,
                                   (0, 0, 100, 100), self.scale_text_sizes)
        self.items.append(self.btnlist)

        self.board_items = self.btnlist.items


