import constants as c_
from math import *
from my_maths import *
from snake_body import snake_body
from ball import ball
from img_holder import img_holder
class snake_head(snake_body):
    def __init__(self, snake, id, prev_ball, next_ball, obj_group, stor, x, y,
                 img_gr = c_._IG_HEAD, img_id = 0,
                 friction = 0.1, solidity = 1.0, string = "anonymous ball",
                 def_size = c_._WH_HEAD):
        snake_body.__init__(self, snake, id, prev_ball, next_ball, obj_group, stor,
                            x, y, img_gr, img_id, friction, solidity,
                            string, friction, def_size)
#        self.attached = True
        self.ih_face = img_holder()
#        self.player = (obj_group == c_._OG_PLAYER1) and self.stor.p1 or self.stor.p2

    def get_image_angle(self):
        t = self.snake.target_ball
        toret = angle_a_to_b(self.crd, t.crd)
        return toret

    def render(self, stor, visible):
        ball.render(self, stor, visible)
        ball.render(self, stor, visible, self.get_face_img_data)

    def get_face_img_data(self):
        ang = self.get_image_angle()
        return self.stor.imgf.get_image(self.ih_face, angle = ang)
        
