import pygame
from img_holder import img_holder
import constants as c_
from common_ import blit_

class icon:
    def __init__(self, stor, rect = pygame.Rect(0, 0, 0, 0), ih = "NOTSET"):
        self.stor = stor
        self.rect = pygame.Rect(rect)
        if ih == "NOTSET": ih = img_holder(c_._IG_ICON_NONE, 0)
        self.ih = ih

    def render(self, visible, func = None):
        if not func: func = self.get_image
        img, img_r = func()

        img_r.center = self.rect.center

        blit_(self.stor, img, img_r, visible)
        
    def get_image(self):
#        print "icon image:"
#        print self.stor.imgf.get_image(img_holder(c_._IG_ICON_NONE, 0))
        return self.stor.imgf.get_image(self.ih).img
        
